=== debian/changelog ===
camlp5 (8.00.02-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:33:00 +0100

camlp5 (8.00.02-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 19 Jan 2022 18:22:38 +0100
